const { isMainThread, parentPort, workerData } = require('worker_threads')
const logger = require('../utils/logger.js')
const actions = require('../utils/actions.js')

if (!isMainThread) {
  logger.DebugLog('Starting worker thread', 'searchdata', 1)
  logger.DebugLog(workerData, 'searchdata', 1)
  const { data, question, subj, recData } = workerData

  parentPort.postMessage(
    SearchData(actions.LoadJSONFromObject(data), question, subj, recData)
  )
} else {
  logger.Log(
    'Porcess data should not run on main thread!',
    logger.GetColor('redbg')
  )
}

function SearchData(data, question, subj, recData) {
  return data.Search(question, subj, recData)
}
